type pointer

type t_que_dis_ena = QUERY | DISABLE | ENABLE
type t_off_on = OFF | ON


(* ------------------------------  SDL.h  -------------------------------- *)
type t_init =
| INIT_TIMER
| INIT_AUDIO
| INIT_VIDEO
| INIT_CDROM
| INIT_JOYSTICK
| INIT_NOPARACHUTE
| INIT_EVENTTHREAD
| INIT_EVERYTHING
;;

external init : t_init list -> unit = "MLSDL_init"
external init_sub_system : t_init list -> unit = "MLSDL_init_sub_system"
external quit_sub_system : t_init -> unit = "MLSDL_quit_sub_system"
external was_init : (t_init list) -> (t_init list) = "MLSDL_was_init"
external quit : unit -> unit = "MLSDL_quit"

(* --------------------------- SDL_keysym.h ---------------------------- *)

  (* SDLKey enum *)
type t_key = K_UNKNOWN | K_FIRST | K_BACKSPACE | K_TAB | K_CLEAR | K_RETURN | K_PAUSE | K_ESCAPE | K_SPACE | K_EXCLAIM | K_QUOTEDBL | K_HASH | K_DOLLAR | K_AMPERSAND | K_QUOTE | K_LEFTPAREN | K_RIGHTPAREN | K_ASTERISK | K_PLUS | K_COMMA | K_MINUS | K_PERIOD | K_SLASH
| K_0 | K_1 | K_2 | K_3 | K_4 | K_5 | K_6 | K_7 | K_8 | K_9 | K_COLON | K_SEMICOLON | K_LESS | K_EQUALS | K_GREATER | K_QUESTION | K_AT
| K_LEFTBRACKET | K_BACKSLASH | K_RIGHTBRACKET | K_CARET | K_UNDERSCORE | K_BACKQUOTE
| K_A | K_B | K_C | K_D | K_E | K_F | K_G | K_H | K_I | K_J | K_K | K_L | K_M | K_N | K_O | K_P | K_Q | K_R | K_S | K_T | K_U | K_V | K_W | K_X | K_Y | K_Z | K_DELETE
| K_WORLD_0 | K_WORLD_1 | K_WORLD_2 | K_WORLD_3 | K_WORLD_4 | K_WORLD_5 | K_WORLD_6 | K_WORLD_7 | K_WORLD_8 | K_WORLD_9 | K_WORLD_10 | K_WORLD_11 | K_WORLD_12 | K_WORLD_13 | K_WORLD_14 | K_WORLD_15 | K_WORLD_16 | K_WORLD_17 | K_WORLD_18 | K_WORLD_19 | K_WORLD_20 | K_WORLD_21 | K_WORLD_22 | K_WORLD_23 | K_WORLD_24 | K_WORLD_25 | K_WORLD_26 | K_WORLD_27 | K_WORLD_28 | K_WORLD_29 | K_WORLD_30 | K_WORLD_31 | K_WORLD_32 | K_WORLD_33 | K_WORLD_34 | K_WORLD_35 | K_WORLD_36 | K_WORLD_37 | K_WORLD_38 | K_WORLD_39 | K_WORLD_40 | K_WORLD_41 | K_WORLD_42 | K_WORLD_43 | K_WORLD_44 | K_WORLD_45 | K_WORLD_46 | K_WORLD_47 | K_WORLD_48 | K_WORLD_49 | K_WORLD_50 | K_WORLD_51 | K_WORLD_52 | K_WORLD_53 | K_WORLD_54 | K_WORLD_55 | K_WORLD_56 | K_WORLD_57 | K_WORLD_58 | K_WORLD_59 | K_WORLD_60 | K_WORLD_61 | K_WORLD_62 | K_WORLD_63 | K_WORLD_64 | K_WORLD_65 | K_WORLD_66 | K_WORLD_67 | K_WORLD_68 | K_WORLD_69 | K_WORLD_70 | K_WORLD_71 | K_WORLD_72 | K_WORLD_73 | K_WORLD_74 | K_WORLD_75 | K_WORLD_76 | K_WORLD_77 | K_WORLD_78 | K_WORLD_79 | K_WORLD_80 | K_WORLD_81 | K_WORLD_82 | K_WORLD_83 | K_WORLD_84 | K_WORLD_85 | K_WORLD_86 | K_WORLD_87 | K_WORLD_88 | K_WORLD_89 | K_WORLD_90 | K_WORLD_91 | K_WORLD_92 | K_WORLD_93 | K_WORLD_94 | K_WORLD_95
| K_KP0 | K_KP1 | K_KP2 | K_KP3 | K_KP4 | K_KP5 | K_KP6 | K_KP7 | K_KP8 | K_KP9 | K_KP_PERIOD | K_KP_DIVIDE | K_KP_MULTIPLY | K_KP_MINUS | K_KP_PLUS | K_KP_ENTER | K_KP_EQUALS
| K_UP | K_DOWN | K_RIGHT | K_LEFT | K_INSERT | K_HOME | K_END | K_PAGEUP | K_PAGEDOWN
| K_F1 | K_F2 | K_F3 | K_F5 | K_F6 | K_F7 | K_F8 | K_F9 | K_F10 | K_F11 | K_F12 | K_F13 | K_F14 | K_F15
| K_NUMLOCK | K_CAPSLOCK | K_SCROLLLOCK | K_RSHIFT | K_LSHIFT | K_RCTRL | K_LCTRL | K_RALT | K_LAT | K_RMETA | K_LMETA | K_LSUPER | K_RSUPER | K_MODE | K_COMPOSE
| K_HELP | K_PRINT | K_SYSREQ | K_BREAK | K_MENU | K_POWER | K_EURO


  (* SDLMod enum *)
type t_mod = KMOD_NONE | KMOD_LSHIFT | KMOD_RSHIFT | KMOD_LCTRL | KMOD_RCTRL 
| KMOD_LALT | KMOD_RALT | KMOD_LMETA | KMOD_RMETA
| KMOD_NUM | KMOD_CAPS | KMOD_MODE | KMOD_RESERVED



(* --------------------------- SDL_keyboard.h ------------------------- *)
type t_key_sym = 
    {scancode : int; sym : t_key; modif : t_mod; unicode : int} (*obsolete*)
(* #define SDL_ALL_HOTKEYS 	0xFFFFFFFF *)
external enable_unicode : t_que_dis_ena -> t_off_on = "MLSDL_enable_unicode"

let default_repeat_delay = 500 and default_repeat_interval = 30

external enable_key_repeat : int -> int -> unit = "MLSDL_enable_key_repeat"
(* Uint8 *SDL_GetKeyState(int *numkeys) -- bad function *)
external get_mod_state : unit -> (t_mod list) = "MLSDL_get_mod_state"
external set_mod_state : t_mod list -> unit = "MLSDL_set_mod_state"
external get_key_name : t_key -> string = "MLSDL_get_key_name"

(* --------------------------- SDL_active.h ---------------------------- *)

type t_app_state = APPMOUSEFOCUS | APPINPUTFOCUS | APPACTIVE 
external get_app_state : unit -> (t_app_state list) = "MLSDL_get_app_state"

(* -------------------------- SDL_events.h ----------------------------- *)

(* Event enum *)
type t_event_type =
  NOEVENT
| ACTIVEEVENT
| KEYDOWN
| KEYUP
| MOUSEMOTION
| MOUSEBUTTONDOWN
| MOUSEBUTTONUP
| JOYAXISMOTION
| JOYBALLMOTION
| JOYHATMOTION
| JOYBUTTONDOWN
| JOYBUTTONUP
| QUIT
| SYSWMEVENT
| EVENT_RESERVEDA
| EVENT_RESERVEDB
| VIDEORESIZE
| VIDEOEXPOSE
| EVENT_RESERVED2
| EVENT_RESERVED3
| EVENT_RESERVED4
| EVENT_RESERVED5
| EVENT_RESERVED6
| EVENT_RESERVED7
| USEREVENT

type t_pressrelease = RELEASED | PRESSED

type t_lost_gained = LOST | GAINED
type t_active_event = t_lost_gained*t_app_state

type t_keyboard_event = int*t_pressrelease*int*t_key*(t_mod list)*int

type t_mouse_button = NOBUTTON | LEFT | RIGHT
type t_mouse_motion_event = int*t_mouse_button*int*int*int*int
type t_mouse_button_event = int*t_mouse_button*t_pressrelease*int*int
type t_joy_axis_event = int*int*int*int
type t_joy_ball_event = int*int*int*int
type t_joy_hat_event = int*int*int
type t_joy_button_event = int*int*int
type t_resize_event = int*int
type t_user_event = {code : int; data1 : pointer; data2 : pointer}
(* tsyswmevent not implemented in trial version *)
type t_sys_wm_event

type t_event = 
    | None			
    | Active of t_active_event 	
    | Key of t_keyboard_event	
    | Motion of t_mouse_motion_event 
    | Button of t_mouse_button_event 
    | Jaxis of t_joy_axis_event	
    | Jball of t_joy_ball_event	
    | Jhat of t_joy_hat_event	
    | Jbutton of t_joy_button_event
    | Resize of t_resize_event	
    | Expose
    | Equit 			
    | User of t_user_event		
    | Syswm of t_sys_wm_event
;;

(* Event functions *)
external pump_events : unit -> unit = "MLSDL_pump_events"
(* typedef enum {} SDL_eventaction *)
(* int SDL_PeepEvents (...) *)
external poll_event : unit -> t_event = "MLSDL_poll_event"
external wait_event : unit -> t_event = "MLSDL_wait_event"
(* pushevent ??????????????????????? *)
(* seteventfilter ?????????????????? *)
(* geteventfilter ?????????????????? *)
external  event_state : t_event_type -> t_que_dis_ena -> t_off_on 
    = "MLSDL_event_state"

(* _______________________________________________________________________ *)


(* Timer section *)

external get_ticks : unit -> int = "MLSDL_get_ticks"
external delay : int -> unit = "MLSDL_delay"


(* ---------------------------------- SDL_video.h --------------------- *)

type t_rect = int * int * int * int
type t_RGB = int * int * int
type t_RGBA = int * int * int * int
type t_palette = {ncolors : int; colors : pointer}
type t_cpixel_format
type t_pixel_format = {
    cpixel_format : t_cpixel_format;
    palette : pointer;
    bits_per_pixel : int;
    bytes_per_pixel : int;
    loss : t_RGBA;
    shift : t_RGBA;
    mask : int32*int32*int32*int32;
    colorkey : int32;
    alpha : int;
}

type t_csurface
type t_surface = {
    csurface : t_csurface;
    flags : int32;
    format : t_pixel_format;
    w : int; h : int;
    pitch : int;
    pixels : pointer;
    offset : int;
    hwdata : pointer;
    clip_rect : t_rect;
    unused1 : int32;
    locked : int32;
    map : pointer;
    format_version : int;
    refcount : int;
}

type t_surftype = 
| SWSURFACE
| HWSURFACE
| ASYNCBLIT
| ANYFORMAT
| HWPALETTE
| DOUBLEBUF
| FULLSCREEN
| OPENGL
| OPENGLBLIT
| RESIZEABLE
| NOFRAME
| HWACCEL
| SRCCOLORKEY
| RLEACCELOK
| RLEACCEL
| SRCALPHA
| PREALLOC


external mustlock : t_surface -> bool = "MLSDL_mustlock"

type t_video_info = {
    hw_available : bool;
    wm_available : bool;
    blit_hw : bool;
    blit_hw_CC : bool;
    blit_hw_A : bool;
    blit_sw : bool;
    blit_sw_CC : bool;
    blit_sw_A : bool;
    blit_fill : bool;
    video_mem : int;
    vfmt : t_pixel_format;
}

(* also YUV* macros are omitted *)
type tvideoinfo
type toverlay

(* it was SDL_GLattr *)
type t_gl_attr =
| GL_RED_SIZE
| GL_GREEN_SIZE
| GL_BLUE_SIZE
| GL_ALPHA_SIZE
| GL_BUFFER_SIZE
| GL_DOUBLEBUFFER
| GL_DEPTH_SIZE
| GL_STENCIL_SIZE
| GL_ACCUM_RED_SIZE
| GL_ACCUM_GREEN_SIZE
| GL_ACCUM_BLUE_SIZE
| GL_ACCUM_ALPHA_SIZE


(* SDL_VideoInit *)
external video_quit : unit -> unit = "MLSDL_video_quit"
external get_video_info : unit -> t_video_info = "MLSDL_get_video_info"
external set_video_mode : int -> int -> int -> (t_surftype list) -> t_surface 
    = "MLSDL_set_video_mode"
    
external update_rect : t_surface -> t_rect -> unit= "MLSDL_update_rect"
let rec update_rects surf rects_list = 
    match rects_list with
    | [] -> ()
    | h::t -> update_rect surf h; update_rects surf t

external flip : t_surface -> unit = "MLSDL_flip"
external set_gamma : float*float*float -> unit = "MLSDL_set_gamma"
(* setgammaramp *)
(* getgammaramp *)
(* setcolors (No need as it is for 8bit) *)
(* setpalette also *)
external map_RGB : t_pixel_format -> t_RGB -> int32 = "MLSDL_map_RGB"
external map_RGBA : t_pixel_format -> t_RGBA -> int32 = "MLSDL_map_RGBA"

(* maybe pixel in CAML must be a pointer to a C pixel -- not an int32 *)
external get_RGB : int32 -> t_pixel_format -> t_RGB = "MLSDL_get_RGB"
external get_RGBA : int32 -> t_pixel_format -> t_RGBA = "MLSDL_get_RGBA"

external create_RGB_surface : (t_surftype list) -> (int*int*int)
				-> (int32*int32*int32*int32) -> t_surface 
				    = "MLSDL_create_RGB_surface"
external create_RGB_surface_from : pointer -> (int*int*int) -> int 
				-> (int32*int32*int32*int32) -> t_surface
					="MLSDL_create_RGB_surface_from"

external free_surface : t_surface -> unit = "MLSDL_free_surface"
external lock_surface : t_surface -> unit = "MLSDL_lock_surface"
external unlock_surface : t_surface -> unit = "MLSDL_unlock_surface"

external load_BMP : string -> t_surface = "MLSDL_load_BMP"

external set_color_key : t_surface->t_surftype list->int32->unit="MLSDL_set_color_key"
external set_color_key_00 : t_surface->t_surftype list->unit= "MLSDL_set_color_key_00"
external set_alpha : t_surface -> t_surftype list -> int -> unit = "MLSDL_set_alpha"

external set_clip_rect : t_surface -> t_rect -> unit = "MLSDL_set_clip_rect"
external convert_surface : t_surface -> t_pixel_format -> (t_surftype list)
				-> t_surface = "MLSDL_convert_surface"
external blit_surface : t_surface -> t_rect -> t_surface -> t_rect
			    -> unit = "MLSDL_blit_surface"
external fill_rect : t_surface -> t_rect -> int32 -> unit = "MLSDL_fill_rect"
external display_format : t_surface -> t_surface = "MLSDL_display_format"
external display_format_alpha : t_surface -> t_surface = "MLSDL_display_format_alpha"
external gl_set_attribute : t_gl_attr -> int -> unit = "MLSDL_gl_set_attribute"
external gl_get_attribute : t_gl_attr -> int = "MLSDL_gl_get_attribute"
external gl_swap_buffers : unit -> unit = "MLSDL_gl_swap_buffers"

external show_cursor: t_que_dis_ena -> t_que_dis_ena = "MLSDL_ShowCursor"
