#include <SDL/SDL.h>
#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>

#include "shared.h"

value MLSDL_enable_unicode(value enable)
{
    CAMLparam1(enable);
    CAMLreturn(Val_int(SDL_EnableUNICODE(Int_val(enable)-1)+1));
}

void MLSDL_enable_key_repeat(value delay, value interval)
{
    CAMLparam2(delay, interval);
    if (SDL_EnableKeyRepeat(Int_val(delay), Int_val(interval)) == -1)
	fail();
    else CAMLreturn0;
}

// Uint8 *SDL_GetKey_State(int *numkeys) -- bad function

value MLSDL_get_mod_state(value u)
{
    CAMLparam1(u);
    CAMLreturn(mask_to_ML_flags(SDL_GetModState(), 
	flag_to_mod, FLAG_TO_MOD_SIZE));
}

void MLSDL_set_mod_state(value flags)
{
    CAMLparam1(flags);
    SDL_SetModState(ML_flags_to_mask(flags, flag_to_mod));
    CAMLreturn0;
}    

value MLSDL_get_key_name(value ML_key)
{
    CAMLparam1(ML_key); /* perhaps GC likes CAMLlocal(toreturn); toreturn= */
    CAMLreturn(copy_string(SDL_GetKeyName(flag_to_key[Int_val(ML_key)])));
}
